version: "3"
services:
  api-gateway:
    build:
      context: "."
      dockerfile: "./api-gateway/Dockerfile"
    depends_on:
      - users-service
      - institution-service
      - health-service
      - medi-service
      - messenger-service
    environment:
      - USERS_SERVICES_URI=http://users-service:7100
      - INSTITUTION_SERVICES_URI=http://institution-service:7101
      - HEALTH_SERVICES_URI=http://health-service:7102
    ports:
      - 7001:7001
    volumes:
      - ./api-gateway:/opt/app

  users-service:
    build:
      context: "."
      dockerfile: "./users-service/Dockerfile"
    depends_on:
      - users-service-db
    environment:
      - DB_URL=mysql://root:password@users-service-db/db?charset=UTF8
    ports:
      - 7100:7100
    volumes:
      - ./users-service:/opt/app

  users-service-db:
    environment:
      - MYSQL_ROOT_PASSWORD=password
      - MYSQL_DATABASE=db
    image: mariadb:10.4
    ports:
      - 0.0.0.0:7200:3306

  institution-service:
    build:
      context: "."
      dockerfile: "./institution-service/Dockerfile"
    depends_on:
      - institution-service-db
    environment:
      - DB_URL=mysql://root:password@institution-service-db/db?charset=UTF8
    ports:
      - 7101:7101
    volumes:
      - ./institution-service:/opt/app

  institution-service-db:
    environment:
      - MYSQL_ROOT_PASSWORD=password
      - MYSQL_DATABASE=db
    image: mariadb:10.4
    ports:
      - 0.0.0.0:7201:3306

  health-service:
    build:
      context: "."
      dockerfile: "./health-service/Dockerfile"
    depends_on:
      - health-service-db
    environment:
      - DB_URL=mysql://root:password@health-service-db/db?charset=UTF8
    ports:
      - 7102:7102
    volumes:
      - ./health-service:/opt/app

  health-service-db:
    environment:
      - MYSQL_ROOT_PASSWORD=password
      - MYSQL_DATABASE=db
    image: mariadb:10.4
    ports:
      - 0.0.0.0:7202:3306

  medi-service:
    build:
      context: "."
      dockerfile: "./medi-service/Dockerfile"
    depends_on:
      - medi-service-db
    environment:
      - DB_URL=mysql://root:password@medi-service-db/db?charset=UTF8
    ports:
      - 7103:7103
    volumes:
      - ./medi-service:/opt/app

  medi-service-db:
    environment:
      - MYSQL_ROOT_PASSWORD=password
      - MYSQL_DATABASE=db
    image: mariadb:10.4
    ports:
      - 0.0.0.0:7203:3306

  messenger-service:
    build:
      context: "."
      dockerfile: "./messenger-service/Dockerfile"
    depends_on:
      - messenger-service-db
    environment:
      - DB_URL=mysql://root:password@messenger-service-db/db?charset=UTF8
    ports:
      - 7104:7104
    volumes:
      - ./messenger-service:/opt/app

  messenger-service-db:
    environment:
      - MYSQL_ROOT_PASSWORD=password
      - MYSQL_DATABASE=db
    image: mariadb:10.4
    ports:
      - 0.0.0.0:7204:3306
